// D import file generated from 'derelict/opengl3/wgl.d'
module derelict.opengl3.wgl;
version (Windows)
{
	private 
	{
		import std.string;
		import derelict.util.wintypes;
		import derelict.util.system;
	}
	extern (Windows) nothrow @nogc 
	{
		alias da_wglCopyContext = BOOL function(void*, void*);
		alias da_wglCreateContext = void* function(void*);
		alias da_wglCreateLayerContext = void* function(void*, int);
		alias da_wglDeleteContext = BOOL function(void*);
		alias da_wglDescribeLayerPlane = BOOL function(void*, int, int, UINT, LAYERPLANEDESCRIPTOR*);
		alias da_wglGetCurrentContext = void* function();
		alias da_wglGetCurrentDC = void* function();
		alias da_wglGetLayerPaletteEntries = int function(void*, int, int, int, COLORREF*);
		alias da_wglGetProcAddress = FARPROC function(LPCSTR);
		alias da_wglMakeCurrent = BOOL function(void*, void*);
		alias da_wglRealizeLayerPalette = BOOL function(void*, int, BOOL);
		alias da_wglSetLayerPaletteEntries = int function(void*, int, int, int, COLORREF*);
		alias da_wglShareLists = BOOL function(void*, void*);
		alias da_wglSwapLayerBuffers = BOOL function(void*, UINT);
		alias da_wglUseFontBitmapsW = BOOL function(void*, DWORD, DWORD, DWORD);
		alias da_wglUseFontOutlinesW = BOOL function(void*, DWORD, DWORD, DWORD, FLOAT, FLOAT, int, GLYPHMETRICSFLOAT*);
	}
	__gshared 
	{
		da_wglCopyContext wglCopyContext;
		da_wglCreateContext wglCreateContext;
		da_wglCreateLayerContext wglCreateLayerContext;
		da_wglDeleteContext wglDeleteContext;
		da_wglDescribeLayerPlane wglDescribeLayerPlane;
		da_wglGetCurrentContext wglGetCurrentContext;
		da_wglGetCurrentDC wglGetCurrentDC;
		da_wglGetLayerPaletteEntries wglGetLayerPaletteEntries;
		da_wglGetProcAddress wglGetProcAddress;
		da_wglMakeCurrent wglMakeCurrent;
		da_wglRealizeLayerPalette wglRealizeLayerPalette;
		da_wglSetLayerPaletteEntries wglSetLayerPaletteEntries;
		da_wglShareLists wglShareLists;
		da_wglSwapLayerBuffers wglSwapLayerBuffers;
		da_wglUseFontBitmapsW wglUseFontBitmapsW;
		da_wglUseFontOutlinesW wglUseFontOutlinesW;
	}
	alias wglUseFontBitmaps = wglUseFontBitmapsW;
	alias wglUseFontOutlines = wglUseFontOutlinesW;
	package 
	{
		void loadPlatformGL(void delegate(void**, string, bool doThrow) bindFunc);
		void* loadGLFunc(string symName);
		bool hasValidContext();
	}
}
